#pragma once

namespace ActiveBasic{ namespace Common{


struct Platform
{
	enum EnumType
	{
		X86,
		X64,
	};
};

// ^[Qbg
struct TargetModuleType
{
	enum EnumType
	{
		Exe = 0,
		Dll,
		Sll,
	};
};

class Environment
{
	static std::string rootPath;
	static bool isRemoveExternal;
public:
	static void SetAbdevRootPath( const std::string &rootPath );

	static const std::string GetAbdevRootPath();

	static const std::string GetUserAppDir();

	static const std::string GetAbdevSystemDirPath()
	{
		return GetAbdevRootPath() + "\\system";
	}

	static const std::string GetCompilerExePath( Platform::EnumType platform );

	static bool IsRemoveExternal()
	{
		return isRemoveExternal;
	}
	static void SetRemoveExternalMark( bool isRemoveExternalMark )
	{
		Environment::isRemoveExternal = isRemoveExternalMark;
	}

private:
	Environment();
	Environment(Environment const&);
	Environment& operator =(Environment const&);
	~Environment();
};

BOOL EnableNX();
void SetHeapOptions();

}}
